<?php

class GoogleMapMarkerController extends RController
{
    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    // public $layout='//layouts/column2';

    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate($map_id)
    {
        $model = new GoogleMapMarker;
        $model->map_id = $map_id;

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['GoogleMapMarker'])) {
            $model->attributes = $_POST['GoogleMapMarker'];
            $model = $this->processIcon($model);
            if ($model->save()) {
                $this->redirect(array('admin', 'map_id' => $model->map_id));
            }
        }

        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model = $this->loadModel($id);
        $model->icon_select = $model->icon;

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['GoogleMapMarker'])) {
            $model->attributes = $_POST['GoogleMapMarker'];
            $model = $this->processIcon($model);
            if ($model->save()) {
                $this->redirect(array('admin', 'map_id' => $model->map_id));
            }
        }

        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
        $this->loadModel($id)->delete();

        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex()
    {
        $dataProvider = new CActiveDataProvider('GoogleMapMarker');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin($map_id)
    {
        $model = new GoogleMapMarker('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['GoogleMapMarker']))
            $model->attributes = $_GET['GoogleMapMarker'];
        $model->map_id = $map_id;
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return GoogleMapMarker the loaded model
     * @throws CHttpException
     */
    public function loadModel($id)
    {
        $model = GoogleMapMarker::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param GoogleMapMarker $model the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'google-map-marker-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    protected function processIcon(GoogleMapMarker $model)
    {
        $old_val = $model->icon_image;
        $model->icon_image = CUploadedFile::getInstance($model, 'icon_image');

        if ($model->icon_image !== NULL) {
            if ($model->validate(null, false)) {
                $picname = uniqid() . '.' . $model->icon_image->getExtensionName();
                $saveDir = Yii::app()->params['uploadDir'] . get_class($model);
                $path = $saveDir . '/' . $picname;
                if ($model->icon_image->saveAs($path)) {
                    $imageObj = Yii::app()->image->load($path);
                    $new_height = 60;
                    $new_width = round(($imageObj->width * $new_height) / $imageObj->height);
                    $imageObj->resize($new_width, $new_height, Image::NONE);
                    $imageObj->save($saveDir . '/thumbs/' . $picname);
                    $model->icon_image = $picname;
                    $model->icon = $model->icon_image;
                    return $model;
                }
            }
        }

        $model->icon = $model->icon_select;
        return $model;
    }
}
